<?php

use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$sIntrospection = Util::introspection();
$sCodeGenerator = Util::codeGenerator();

$sCodeGenerator->setTemplate('ApplicationPhpRenderer');

$fullClassName = 'Application\View\Renderer\PhpRenderer';

?>
    <h1>Génération du PhpRenderer de l'application</h1>

    <div class="alert alert-warning">
        <span class="glyphicon glyphicon glyphicon-thumbs-up"
              style="float: left;font-size:50pt;margin-right:.2em;margin-bottom:.2em"></span>
        Le PhpRenderer permet de bénéficier de l'auto-complétion des view helpers depuis vos vues.
        Pour l'utiliser, il convient de déclarer la ligne suivante au début de chaque vue :

        <?php phpDump('/* @var $this \\' . $fullClassName . ' */'); ?>

    </div>

<?php

$vhs = $sIntrospection->getViewHelpers();

$methods = [];
foreach ($vhs as $key => $class) {
    $rc = new \ReflectionClass($class);
    if ($rc->hasMethod('__invoke')) {
        $method    = $rc->getMethod('__invoke');
        $methods[] = ' * ' . Util::getMethodDocDeclaration($rc->getMethod('__invoke'), $key, '\\' . $class);
    } else {
        $methods[] = " * @method \\$class $key()";
    }
}

$params   = [
    'methods' => implode("\n", $methods),
];
$fileName = Util::classNameToFileName($fullClassName);
$sCodeGenerator->setParams($params)->generateToHtml($fileName)->generateToFile($fileName);

echo '<div class="alert alert-info" role="alert">Le fichier est récupérable dans le dossier ' . $sCodeGenerator->getOutputDir() . '</div>';