<?php

use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$sConfig        = Util::config();
$sIntrospection = Util::introspection();
$sCodeGenerator = Util::codeGenerator();

$sCodeGenerator->setTemplate('EntityAwareTrait');

echo '<h1>Liste des fichiers générés</h1>';

foreach ($sConfig->getNamespacesEntities() as $namespace) {
    echo '<h2>' . $namespace . '</h2>';

    $entities = $sIntrospection->getDbEntities($namespace);
    foreach ($entities as $fullClass) {
        $params = $sCodeGenerator->generateEntityParams([
            'generateTrait'   => true,
            'classname'       => $fullClass,
            'rootNamespace'   => $namespace,
            'generateFactory' => false,
            'useGetter'       => true,
        ]);
        $sCodeGenerator->generateFiles($params);
    }
}

echo '<div class="alert alert-info" role="alert">Les fichiers sont récupérables dans le dossier ' . $sCodeGenerator->getOutputDir() . '</div>';