<?php

use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$sConfig        = Util::config();
$sIntrospection = Util::introspection();
$sCodeGenerator = Util::codeGenerator();

$sCodeGenerator->setTemplate('FormAwareInterface');

echo '<h1>Liste des fichiers générés</h1  code>';

foreach ($sConfig->getNamespacesForms() as $namespace) {
    echo '<h2>' . $namespace . '</h2>';

    $forms = $sIntrospection->getForms($namespace, \Zend\Form\Form::class);
    foreach ($forms as $name => $fullClass) {
        $params = $sCodeGenerator->generateFormParams([
            'type'              => false === strpos($fullClass, 'Fieldset') ? 'Form' : 'Fieldset',
            'classname'         => $fullClass,
            'name'              => $name,
            'generateInterface' => true,
            'generateTrait'     => false,
            'generateConfig'    => false,
            'generateFactory'   => false,
            'useGetter'         => true,
            'rootNamespace'     => $namespace,
        ]);
        unset($params['Class']);
        $sCodeGenerator->generateFiles($params);
    }
}

echo '<div class="alert alert-info" role="alert">Les fichiers sont récupérables dans le dossier ' . $sCodeGenerator->getOutputDir() . '</div>';