<?php

use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$sConfig        = Util::config();
$sIntrospection = Util::introspection();
$sCodeGenerator = Util::codeGenerator();

$sCodeGenerator->setTemplate('ServiceAwareTrait');

echo '<h1>Liste des fichiers générés</h1>';

foreach ($sConfig->getNamespacesServices() as $namespace) {
    echo '<h2>' . $namespace . '</h2>';

    $services = $sIntrospection->getServices($namespace);
    foreach ($services as $name => $fullClass) {
        $params = $sCodeGenerator->generateServiceParams([
            'classname'       => $fullClass,
            'name'            => $name,
            'generateTrait'   => true,
            'generateFactory' => false,
            'useGetter'       => true,
        ]);
        unset($params['Class']);
        $sCodeGenerator->generateFiles($params);
    }
}

echo '<div class="alert alert-info" role="alert">Les fichiers sont récupérables dans le dossier ' . $sCodeGenerator->getOutputDir() . '</div>';